        include "doslib.h"
        include "tios.h"
        xdef    _main
        xdef    _comment
_main:                                     
        btst.b  #0,doslib::status_byte
        beq     no_dos

        jsr     doslib::GetNextComm
        tst.l   d0                      ;was there another command?
        bne     switch_folder           ;if there was, try to switch to that fold
        jsr     doslib::Scroll          
        jsr     doslib::PrintPath
        rts
switch_folder:
        move.l  #2,-(sp)                ;push # bytes
        move.l  #doslib::command,-(sp)          ;push str1
        pea     cd_two_dots(PC)         ;push str2
        jsr     tios::strncmp           ;compare
        lea     12(sp),sp
        tst.w   d0                      ;?
        beq     cd..                    ;go there
        move.l  #doslib::command,-(sp)          ;push add of folder name to check
        move.w  FOLDER_LIST_HANDLE,-(sp)
        jsr     tios::FindSymEntry      ;get folder structure add., if any
        lea     6(sp),sp                ;update stack
        cmp.l   #0,a0                   ;was a folder found?
        beq     folder_not_found
        move.w  tios::SYM_ENTRY.hVal(a0),doslib::cur_fold_hand  ;store handle
        move.l  #8,-(sp)                ;push size
        move.l  #doslib::command,-(sp)          ;source
        move.l  #doslib::cur_fold,-(sp)  ;dest
        jsr     tios::strncpy           ;copy data
        lea     12(sp),sp
        jsr     doslib::Scroll          
        rts
folder_not_found:
        jsr     doslib::Scroll          
        lea     inv_dir(PC),a0
        clr.w   doslib::char_pos
        jsr     doslib::PutText           
        rts
cd..:                                       
        move.w  FOLDER_LIST_HANDLE,doslib::cur_fold_hand      ;just the list of folders
        rts
no_dos:
        jsr     doslib::DosNotRunning
        rts

_comment        dc.b    "CD 1.0 TiDOS command",0
inv_dir         dc.b    "Invalid directory",0
cd_two_dots     dc.b    "..",0

        end
